
if (!FCNM) {
    var FCNM = {};
}
FCNM.options = {
    getPref: function(pref){
        var prefs = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService);
        prefs = prefs.getBranch("extensions.freeconetmanager.");
        return prefs.getCharPref(pref);
    },
    
    getIntPref: function(pref){
        var prefs = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService);
        prefs = prefs.getBranch("extensions.freeconetmanager.");
        return prefs.getIntPref(pref);
    },
    
    getBoolPref: function(pref){
        var prefs = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService);
        prefs = prefs.getBranch("extensions.freeconetmanager.");
        return prefs.getBoolPref(pref);
    },
    
    setPref: function(pref, value){
        var prefs = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService);
        prefs = prefs.getBranch("extensions.freeconetmanager.");
        prefs.setCharPref(pref, value);
    },
    
    setIntPref: function(pref, value){
        var prefs = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService);
        prefs = prefs.getBranch("extensions.freeconetmanager.");
        prefs.setIntPref(pref, value);
    },
    
    setBoolPref: function(pref, value){
        var prefs = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService);
        prefs = prefs.getBranch("extensions.freeconetmanager.");
        prefs.setBoolPref(pref, value);
    },
    checkStatusChange: function(){
        try {
            if (document.getElementById("prefs.checkStatus.check").hasAttribute("checked")) {
                document.getElementById("prefs.checkStatus.showInStatusbar").disabled = false;
            }
            else {
                document.getElementById("prefs.checkStatus.showInStatusbar").disabled = true;
            }
        } 
        catch (ex) {
            //;
        }
    },
    establishingCallEnableChange: function(){
        try {
            if (document.getElementById("prefs.establishingCall.enable").hasAttribute("checked")) {
                document.getElementById("prefs.establishingCall.from").disabled = false;
            }
            else {
                document.getElementById("prefs.establishingCall.from").disabled = true;
            }
        } 
        catch (ex) {
            //;
        }
    },
    addStatusbarAccount: function(username){
        try {
            var statusbaraccounts = document.getElementById("prefs.statusbar.accounts");
            var tmp = document.createElement("listitem");
            if (this.getPref("statusbar.rotationaccounts").indexOf("|" + username + "|") == -1) 
                tmp.setAttribute("checked", "false");
            else 
                tmp.setAttribute("checked", "true");
            tmp.setAttribute("type", "checkbox");
            tmp.setAttribute("label", username);
            statusbaraccounts.appendChild(tmp);
        } 
        catch (ex) {
            //;
        }
    },
    
    
    deleteStatusbarAccount: function(username){
        try {
            var statusbaraccounts = document.getElementById("prefs.statusbar.accounts").getElementsByTagName("listitem");
            for (var i = 0; i < statusbaraccounts.length; i++) {
                if (statusbaraccounts[i].getAttribute("label") == username) {
                    document.getElementById("prefs.statusbar.accounts").removeChild(statusbaraccounts[i]);
                    break;
                }
            }
            
        } 
        catch (ex) {
            //;
        }
    },
    
    renameStatusbarAccount: function(username, newusername){
        try {
            var statusbaraccounts = document.getElementById("prefs.statusbar.accounts").getElementsByTagName("listitem");
            for (var i = 0; i < statusbaraccounts.length; i++) {
                if (statusbaraccounts[i].getAttribute("label") == username) {
                    statusbaraccounts[i].setAttribute("label", newusername);
                    break;
                }
            }
        } 
        catch (ex) {
            //;
        }
    },
    
    load: function(){
        try {
            switch (this.getIntPref("statusbarshow")) {
                case 1:
                    document.getElementById("statusbar.full").setAttribute("selected", "true");
                    document.getElementById("statusbar.login").setAttribute("selected", "false");
                    document.getElementById("statusbar.amount").setAttribute("selected", "false");
                    break;
                case 2:
                    document.getElementById("statusbar.full").setAttribute("selected", "false");
                    document.getElementById("statusbar.login").setAttribute("selected", "true");
                    document.getElementById("statusbar.amount").setAttribute("selected", "false");
                    break;
                case 3:
                    document.getElementById("statusbar.full").setAttribute("selected", "false");
                    document.getElementById("statusbar.login").setAttribute("selected", "false");
                    document.getElementById("statusbar.amount").setAttribute("selected", "true");
                    break;
                default:
            }
            document.getElementById("prefs.statusbar.rotationtime").value = this.getIntPref("statusbar.rotationtime");
            document.getElementById("prefs.interval").value = this.getIntPref("interval");
            document.getElementById("prefs.alertlimit").value = this.getIntPref("alertlimit");
            document.getElementById("prefs.establishingCall.from").value = this.getPref("call.from");
            document.getElementById("prefs.establishingCall.websiteBlackList").value = this.getPref("usersWebsiteBlackList").split("|||").join("\n");
            document.getElementById("prefs.checkStatus.showInStatusbar").selectedIndex = this.getIntPref("checkStatus.statusbar");
            document.getElementById("prefs.checkStatus.check").setAttribute("checked", this.getBoolPref("checkStatus.check"));
            document.getElementById("prefs.checkStatus.showInStatusbar").disabled = !this.getBoolPref("checkStatus.check");
            document.getElementById("prefs.billing.enable").setAttribute("checked", this.getBoolPref("billing.enabled"));
            document.getElementById("prefs.billing.quantity").value = this.getIntPref("billing.quantity");
            document.getElementById("prefs.establishingCall.enable").setAttribute("checked", this.getBoolPref("call.enabled"));
            document.getElementById("prefs.establishingCall.enableWebsite").setAttribute("checked", this.getBoolPref("call.website"));
            document.getElementById("prefs.establishingCall.enableWebsite.ssl").setAttribute("checked", this.getBoolPref("call.website.ssl"));
            document.getElementById("prefs.establishingCall.from").disabled = !this.getBoolPref("call.enabled");
            var accounts = document.getElementById("prefs.accounts.popup");
            var passwordManager = Components.classes["@mozilla.org/login-manager;1"].getService(Components.interfaces.nsILoginManager);
            var hostname = 'https://centralny.freeconet.pl/';
            var formSubmitURL = 'https://centralny.freeconet.pl/login.php/manager';
            var logins = passwordManager.findLogins({}, hostname, formSubmitURL, null);
            for (var i = 0; i < logins.length; i++) {
                var tmp = document.createElement("menuitem");
                tmp.setAttribute("c-username", logins[i].username.substr(0, logins[i].username.lastIndexOf("@")));
                tmp.setAttribute("c-password", logins[i].password);
                tmp.setAttribute("c-domain", logins[i].username.substr(logins[i].username.lastIndexOf("@") + 1));
                tmp.setAttribute("label", tmp.getAttribute("c-username") + "@" + tmp.getAttribute("c-domain"));
                accounts.appendChild(tmp);
                this.addStatusbarAccount(logins[i].username);
            }
            /*
             var accounts = document.getElementById("prefs.establishingCall.popup");
             var formSubmitURL = 'https://centralny.freeconet.pl/login.php/manager/establishingCallAccounts';
             var logins = passwordManager.findLogins({}, hostname, formSubmitURL, null);
             for (var i = 0; i < logins.length; i++) {
             var tmp = document.createElement("menuitem");
             tmp.setAttribute("c-name", logins[i].username);
             tmp.setAttribute("c-link", logins[i].password);
             tmp.setAttribute("label", logins[i].username);
             accounts.appendChild(tmp);
             }
             */
        } 
        catch (ex) {
            throw ex;
            //;
        }
    },
    
    add: function(){
        try {
            var a = document.createElement("menuitem");
            var params = {
                inn: {
                    username: "",
                    password: "",
                    domain: "sip.freeconet.pl"
                },
                out: null
            };
            window.openDialog("chrome://freeconetmanager/content/accountdialog.xul", "", "chrome, dialog, modal, resizable=yes, centerscreen", params).focus();
            if (params.out) {
                var accounts = document.getElementById("prefs.accounts").getElementsByTagName("menuitem");
                for (var i = 0; i < accounts.length; i++) {
                    if (accounts[i].getAttribute("c-username") == params.out.username) 
                        return;
                }
                a.setAttribute("c-username", params.out.username);
                a.setAttribute("c-password", params.out.password);
                a.setAttribute("c-domain", params.out.domain);
                a.setAttribute("c-username", a.getAttribute("c-username").replace(/^\s+|\s+$/g, ""));
                a.setAttribute("c-password", a.getAttribute("c-password").replace(/^\s+|\s+$/g, ""));
                a.setAttribute("c-domain", a.getAttribute("c-domain").replace(/^\s+|\s+$/g, ""));
                a.setAttribute("label", a.getAttribute("c-username") + "@" + a.getAttribute("c-domain"));
                if (a.getAttribute("c-username").length > 0 && a.getAttribute("c-password").length > 0 && a.getAttribute("c-domain").length > 3) {
                    document.getElementById("prefs.accounts.popup").appendChild(a);
                    this.addStatusbarAccount(a.getAttribute("label"));
                }
            }
        } 
        catch (ex) {
            //;
        }
    },
    
    edit: function(){
        try {
            var a = document.getElementById("prefs.accounts").selectedItem;
            if (a == null) 
                return;
            var params = {
                inn: {
                    username: a.getAttribute("c-username"),
                    password: a.getAttribute("c-password"),
                    domain: a.getAttribute("c-domain")
                },
                out: null
            };
            window.openDialog("chrome://freeconetmanager/content/accountdialog.xul", "", "chrome, dialog, modal, resizable=yes, centerscreen", params).focus();
            if (params.out) {
                a.setAttribute("c-username", params.out.username);
                a.setAttribute("c-password", params.out.password);
                a.setAttribute("c-domain", params.out.domain);
                this.renameStatusbarAccount(a.getAttribute("label"), a.getAttribute("c-username") + "@" + a.getAttribute("c-domain"));
                a.setAttribute("label", a.getAttribute("c-username") + "@" + a.getAttribute("c-domain"));
            }
        } 
        catch (ex) {
            //;
        }
    },
    
    fdelete: function(){
        try {
            this.deleteStatusbarAccount(document.getElementById("prefs.accounts").selectedItem.getAttribute("label"));
            document.getElementById("prefs.accounts.popup").removeChild(document.getElementById("prefs.accounts").selectedItem);
            document.getElementById("prefs.accounts").selectedItem = null;
        } 
        catch (ex) {
            //;
        }
    },
    
    establishingCallAdd: function(){
        try {
            var a = document.createElement("menuitem");
            var params = {
                inn: {
                    name: "",
                    link: "",
                },
                out: null
            };
            window.openDialog("chrome://freeconetmanager/content/establishingCallAccountDialog.xul", "", "chrome, dialog, modal, resizable=yes, centerscreen", params).focus();
            if (params.out) {
                var accounts = document.getElementById("prefs.establishingCall").getElementsByTagName("menuitem");
                for (var i = 0; i < accounts.length; i++) {
                    if (accounts[i].getAttribute("c-name") == params.out.name) 
                        return;
                }
                a.setAttribute("c-name", params.out.name);
                a.setAttribute("c-link", params.out.link);
                a.setAttribute("c-name", a.getAttribute("c-name").replace(/^\s+|\s+$/g, ""));
                a.setAttribute("c-link", a.getAttribute("c-link").replace(/^\s+|\s+$/g, ""));
                a.setAttribute("label", a.getAttribute("c-name"));
                if (a.getAttribute("c-name").length > 0 && a.getAttribute("c-link").length > 0) {
                    document.getElementById("prefs.establishingCall.popup").appendChild(a);
                }
            }
        } 
        catch (ex) {
            //;
        }
    },
    
    establishingCallEdit: function(){
        try {
            var a = document.getElementById("prefs.establishingCall").selectedItem;
            if (a == null) 
                return;
            var params = {
                inn: {
                    name: a.getAttribute("c-name"),
                    link: a.getAttribute("c-link"),
                },
                out: null
            };
            window.openDialog("chrome://freeconetmanager/content/establishingCallAccountDialog.xul", "", "chrome, dialog, modal, resizable=yes, centerscreen", params).focus();
            if (params.out) {
                a.setAttribute("c-name", params.out.name);
                a.setAttribute("c-link", params.out.link);
                a.setAttribute("label", a.getAttribute("c-name"));
            }
        } 
        catch (ex) {
            //;
        }
    },
    
    establishingCallDelete: function(){
        try {
            document.getElementById("prefs.establishingCall.popup").removeChild(document.getElementById("prefs.establishingCall").selectedItem);
            document.getElementById("prefs.establishingCall").selectedItem = null;
        } 
        catch (ex) {
            //;
        }
    },
    clearDb: function(){
        try {
            var file = Components.classes["@mozilla.org/file/directory_service;1"].getService(Components.interfaces.nsIProperties).get("ProfD", Components.interfaces.nsIFile);
            file.append("freeconetmanager");
            if (!file.exists() || !file.isDirectory()) {
                file.create(Components.interfaces.nsIFile.DIRECTORY_TYPE, 0777);
            }
            file.append("fcnm");
            if (!file.exists()) {
                file.create(Components.interfaces.nsIFile.NORMAL_FILE_TYPE, 0600);
            }
            var storageService = Components.classes["@mozilla.org/storage/service;1"].getService(Components.interfaces.mozIStorageService);
            var db = storageService.openDatabase(file);
            db.executeSimpleSQL("DELETE FROM token");
            db.executeSimpleSQL("VACUUM");
            db.close();
        } 
        catch (ex) {
            //;
        }
    },
    save: function(){
        try {
            if (document.getElementById("statusbar.full").getAttribute("selected") == "true") 
                this.setIntPref("statusbarshow", 1);
            if (document.getElementById("statusbar.login").getAttribute("selected") == "true") 
                this.setIntPref("statusbarshow", 2);
            if (document.getElementById("statusbar.amount").getAttribute("selected") == "true") 
                this.setIntPref("statusbarshow", 3);
            var passwordManager = Components.classes["@mozilla.org/login-manager;1"].getService(Components.interfaces.nsILoginManager);
            var nsLoginInfo = new Components.Constructor("@mozilla.org/login-manager/loginInfo;1", Components.interfaces.nsILoginInfo, "init");
            var hostname = 'https://centralny.freeconet.pl/';
            var formSubmitURL = 'https://centralny.freeconet.pl/login.php/manager';
            var logins = passwordManager.findLogins({}, hostname, formSubmitURL, null);
            for (var i = 0; i < logins.length; i++) {
                passwordManager.removeLogin(logins[i]);
            }
            var accounts = document.getElementById("prefs.accounts.popup").getElementsByTagName("menuitem");
            var usedlogins = new Array();
            for (var i = 0; i < accounts.length; i++) {
                if (usedlogins.indexOf(accounts[i].getAttribute("c-username")) != -1) 
                    continue;
                usedlogins.push(accounts[i].getAttribute("c-username"));
                var formLoginInfo = new nsLoginInfo(hostname, formSubmitURL, null, accounts[i].getAttribute("c-username") + "@" + accounts[i].getAttribute("c-domain"), accounts[i].getAttribute("c-password"), 'login', 'password');
                passwordManager.addLogin(formLoginInfo);
            }
            var formSubmitURL = 'https://centralny.freeconet.pl/login.php/manager/establishingCallAccounts';
            var logins = passwordManager.findLogins({}, hostname, formSubmitURL, null);
            for (var i = 0; i < logins.length; i++) {
                passwordManager.removeLogin(logins[i]);
            }
            /*
             var accounts = document.getElementById("prefs.establishingCall.popup").getElementsByTagName("menuitem");
             var usedlogins = new Array();
             for (var i = 0; i < accounts.length; i++) {
             if (usedlogins.indexOf(accounts[i].getAttribute("c-name")) != -1)
             continue;
             usedlogins.push(accounts[i].getAttribute("c-name"));
             var formLoginInfo = new nsLoginInfo(hostname, formSubmitURL, null, accounts[i].getAttribute("c-name"), accounts[i].getAttribute("c-link"), 'login', 'password');
             passwordManager.addLogin(formLoginInfo);
             }
             */
            this.setPref("statusbar.rotationaccounts", "");
            var accounts = document.getElementById("prefs.statusbar.accounts").getElementsByTagName("listitem");
            for (var i = 0; i < accounts.length; i++) {
                if (accounts[i].getAttribute("checked") == "true") {
                    this.setPref("statusbar.rotationaccounts", this.getPref("statusbar.rotationaccounts") + "|" + accounts[i].getAttribute("label") + "|");
                }
            }
            this.setIntPref("statusbar.rotationtime", document.getElementById("prefs.statusbar.rotationtime").value);
            if (parseInt(document.getElementById("prefs.interval").value) < 5) {
                document.getElementById("prefs.interval").value = 5;
            }
            this.setIntPref("interval", document.getElementById("prefs.interval").value);
            this.setIntPref("alertlimit", document.getElementById("prefs.alertlimit").value);
            this.setIntPref("checkStatus.statusbar", document.getElementById("prefs.checkStatus.showInStatusbar").selectedIndex);
            this.setIntPref("billing.quantity", document.getElementById("prefs.billing.quantity").value);
            this.setBoolPref("checkStatus.check", (document.getElementById("prefs.checkStatus.check").getAttribute("checked") == "true" ? true : false));
            this.setBoolPref("billing.enabled", (document.getElementById("prefs.billing.enable").getAttribute("checked") == "true" ? true : false));
            this.setBoolPref("call.enabled", (document.getElementById("prefs.establishingCall.enable").getAttribute("checked") == "true" ? true : false));
            this.setBoolPref("call.website", (document.getElementById("prefs.establishingCall.enableWebsite").getAttribute("checked") == "true" ? true : false));
            this.setBoolPref("call.website.ssl", (document.getElementById("prefs.establishingCall.enableWebsite.ssl").getAttribute("checked") == "true" ? true : false));
            this.setPref("call.from", document.getElementById("prefs.establishingCall.from").value);
            this.setPref("usersWebsiteBlackList", document.getElementById("prefs.establishingCall.websiteBlackList").value.split("\n").join("|||"));
            this.clearDb();
            this.setPref("status", "");
            this.setPref("stankonta", "");
            this.setPref("lastupdate", "");
            this.setPref("statusbar.rotationactual", "");
            this.setPref("statusbar.rotationlastchange", "");
        } 
        catch (ex) {
            //;
        }
    }
};
